!{\src2tex{textfont=tt}}
!!****f* ABINIT/factorial
!! NAME
!! factorial
!!
!! FUNCTION
!! Calculates N! . Returns a (dp) real.
!!
!! COPYRIGHT
!! Copyright (C) 1998-2005 ABINIT group (MT, FJ)
!! This file is distributed under the terms of the 
!! GNU General Public License, see ~ABINIT/Infos/copyright
!! or http://www.gnu.org/copyleft/gpl.txt .
!! For the initials of contributors, see ~ABINIT/Infos/contributors .
!!
!! INPUTS
!!   nn=number to use
!!
!! OUTPUT
!!   factorial= n! (real)
!!
!! PARENTS
!!      gaunt,setsymrhoij
!!
!! CHILDREN
!!
!! SOURCE

 function factorial(nn)

 use defs_basis
 
 implicit none
 
!Arguments ---------------------------------------------
 integer,intent(in) :: nn
 real(dp) :: factorial
 
!Local variables ---------------------------------------
 integer :: ii
 real(dp) :: ff
 
! *********************************************************************

 ff=1.d0
 do ii=2,nn
  ff=ff*dble(ii)
 enddo

 factorial=ff

 end function factorial

!!***
